//+-------------------------------------------------------------------------------+ 
//|                                                              Concentrated.mq4 |
//|                                                   original template by mladen |
//|                                                           this mod by mrtools |
//+-------------------------------------------------------------------------------+
#property copyright "http://www.forex-tsd.com/"
#property link      "http://www.forex-tsd.com/"
#include <stdlib.mqh>
#include <stderror.mqh>
#define  PAUSE_BEFORE_RETRY 500

//
//
//
//
//

#import "kernel32.dll"
int  GetTimeZoneInformation(int& TZInfoArray[]);
#import

//
//
//
//
//

#define TIME_ZONE_ID_UNKNOWN   0
#define TIME_ZONE_ID_STANDARD  1
#define TIME_ZONE_ID_DAYLIGHT  2

//
//
//
//
//

extern string  ExpertName                 = "Scalp_Net";
extern string  Version                    = "v1.6";
extern bool    EcnBroker                  = true;
extern bool    NoHedge                    = false;
extern bool    UseAutoMagic               = true;
extern int     ManualMagic                = 55555555;
extern bool    UseAutomaticMM             = false;
extern bool    AllowMultipleTradesOnBar   = false;
extern bool    AllowOnlyOneActiveTrade    = true;
extern double  Risk                       = 1.50;
extern double  BaseLot                    = 0.1;
extern bool    CloseOnTrendChange         = false;
extern string  ____Positions              = "Positions settings";
extern double  TakeProfitPips             = 100;
extern double  StopLossPips               = 50;
extern double  lTrailingStop              = 20;
extern double  sTrailingStop              = 20;
extern bool    TrailOnlyWhenInProfit      = true;
extern double  CloseWhenProfit            = 0;
extern double  CloseWhenLoss              = 0;
extern bool    AllSymbolsForProfitAndLoss = false;
extern bool    StopWhenClosedAllTrades    = false;
extern bool    SpreadProtection           = false; // If the spread is widen than normal (News time) we will not open positions or continue positions until it normalize
extern int     PipTolerance               = 2;     // value in pips over normal spread to activate the SpreadProtection.

extern string  _                          = "Indicators";
extern string  mas                        = "Ma Settings";
extern int     fastMa                     = 21;
extern int     fastMaMode                 = MODE_EMA;
extern int     slowMa                     = 200;
extern bool    slowMaMode                 = MODE_EMA;
extern string  sar                        = "Parabolic Sar Settings";
extern double  step                       = 0.005;
extern double  maximum                    = 0.05;
extern string  macd                       = "MACD Settings";
extern int     FastMACD                   = 12;
extern int     SlowMACD                   = 26;
extern int     SignalMACD                 = 9;
extern string  xo                         = "XO Settings";
extern int     BoxPeriod                  = 15;
extern int     CurrentBar                 = 1;

extern string  ____voltyTrailingStop      = "Volty trailing stop settings (if used)";
extern bool    UseVoltyTrailingStop       = false;
extern int     vol_timeFrame              = 240;
extern int     Price                      = 0;
extern double  Length                     = 2;
extern double  Phase                      = 0;
extern bool    Double                     = false;
extern int     AtrLength                  = 10; 
extern double  Kv                         = 4;  
extern double  MoneyRisk                  = 1; 
extern int     vol_barToUse               = 1;    
extern int     Volty_initialStopLoss      = 50;

extern string  ____TimeFilter             = "Time filter settings";
extern string  Trade_startFrom            = "00:00";
extern string  Trade_endAt                = "24:00";

extern string __                          = "Setting for friday positions close";
extern bool   CloseOnFriday               = false;
extern int    FridayCloseHour             = 21; 
extern int    FridayCloseMinute           = 59; 

extern string  ____Other                  = "Other Stuff";
extern int     AllowedSlippage            =  5;
extern bool    ShowComments               = true;
extern bool    showMessages               = false;

//
//
//
//
//

int     NumberOfTries = 5;
int     digit = 0;
int     MagicNumber;
int     DontContinue;
int     TZInfoArray[43];
int     IEAMessagesIDLength;

double  Spread,WorstSpread,NormalSpread;
double  pipMultiplier = 1;
double  pPoint;

bool     canEnterNewTrade=true,dummyResult;

string  s_symbol;
string  IEAMessagesID;

#define IEAMessagesIDMagic EMPTY_VALUE
#define IEAMessagesIDExSep "-ex:"

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   s_symbol = Symbol();
   pPoint   = MarketInfo(s_symbol,MODE_POINT);
   if (UseAutoMagic) MagicNumber = GetMagic();
               else  MagicNumber = ManualMagic;  
   
   //
   //
   //
   //
   //
                  
   digit  = MarketInfo(s_symbol,MODE_DIGITS);
   if (digit==2 || digit==4) pipMultiplier = 1;
   if (digit==3 || digit==5) pipMultiplier = 10;
   if (digit==6)             pipMultiplier = 100;
   
   //
   //
   //
   //
   //
   
   NormalSpread = MarketInfo(s_symbol,MODE_SPREAD)/MathPow(10,digit%2);
   
   //
   //
   //
   //
   //
            
   if (AllSymbolsForProfitAndLoss)
            IEAMessagesID = "Scalp_net"+MagicNumber;
   else     IEAMessagesID = "Scalp_net"+MagicNumber+s_symbol;
   IEAMessagesIDLength = StringLen(IEAMessagesID);
   
return(0);
}

//
//
//
//
//

int deinit() 
{ 
   Comment("");
   
return(0); 
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

#define __trendUp       1
#define __trendDown    -1
#define __trendNeutral  0

//
//
//
//
//

int start()
{     
   if (!CheckTerminalStatus()) return(0);
   if (ShowComments)     ChartComment(); 
   if (!IsDllsAllowed()) Comment(" DLL import should be allowed for this EA");       

   //
   //
   //
   //
   //
   
   if (CloseOnFriday && TimeDayOfWeek(TimeCurrent())==5)
   {
     if (TimeHour(TimeCurrent()) > FridayCloseHour ||
        (TimeHour(TimeCurrent())== FridayCloseHour && TimeMinute(TimeCurrent())>= FridayCloseMinute))
     {
       for(int i=OrdersTotal()-1; i>=0; i--)
  	    { 
     	   dummyResult = OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
            if(OrderSymbol()     != s_symbol)    continue;
            if(OrderMagicNumber()!= MagicNumber)  continue;

            if(OrderType()==OP_BUY)  { dummyResult = OrderClose(OrderTicket(),OrderLots(),MarketInfo(s_symbol,MODE_ASK),0,CLR_NONE); continue; }
            if(OrderType()==OP_SELL) { dummyResult = OrderClose(OrderTicket(),OrderLots(),MarketInfo(s_symbol,MODE_BID),0,CLR_NONE); continue; }
       }
       return(0);
     }
   }
   
   //
   //
   //
   //
   //
   

      if (StopLossPips<=0)
           bool forceCloseOnTrendChange = True;
      else      forceCloseOnTrendChange = CloseOnTrendChange; 
           bool stopedTrading           = false;
           int  trendDirection          = findTrend();

                        manageOpenedOrders(trendDirection,forceCloseOnTrendChange,stopedTrading);

      if (stopedTrading) return(0);

   //
   //
   //
   //
   //

         double totalProfit  = 0;
         int    openedBuys   = 0;
         int    openedSells  = 0;
         int    openedOrders = countOpenedOrders(openedBuys,openedSells,totalProfit);
         
         //
         //
         //
         //
         //

         if (CloseWhenProfit>0 &&  totalProfit >= CloseWhenProfit)
         {
            if (StopWhenClosedAllTrades) PostMessage();
                  CloseAll(); openedOrders = countOpenedOrders(openedBuys,openedSells,totalProfit);
         }
         if (CloseWhenLoss > 0 && totalProfit <= -CloseWhenLoss)
         {
            if (StopWhenClosedAllTrades) PostMessage();
                  CloseAll(); openedOrders = countOpenedOrders(openedBuys,openedSells,totalProfit);
         }
         if (FindMessage()) return(0);
      
         //
         //
         //
         //
         //
      
         canEnterNewTrade = true;

            if (AllowOnlyOneActiveTrade) canEnterNewTrade = (openedOrders==0);
            else                         canEnterNewTrade = (countOpenedOnACurrentBar()==0);

   //
   //
   //    time fiter checking
   //
   //
      
         if (canEnterNewTrade)
         {
            string     st1 = normalizeTime(Trade_startFrom);
            string     et1 = normalizeTime(Trade_endAt);
            datetime   ts1  = StrToTime(TimeToStr(TimeCurrent(),TIME_DATE)+st1); datetime ts2 = ts1;
            datetime   te1  = StrToTime(TimeToStr(TimeCurrent(),TIME_DATE)+et1); datetime te2 = te1;
            if (te1<ts1) { ts1 -= 24*60*60; te2 += 24*60*60; }
                    canEnterNewTrade = ((TimeCurrent()>=ts1 && TimeCurrent()<=te1) || (TimeCurrent()>=ts2 && TimeCurrent()<=te2));
         }

   //
   //
   //
   //
   //
   
   if (canEnterNewTrade && trendDirection != __trendNeutral)
   {
      if (!AllowMultipleTradesOnBar) if (countClosedOrders()>0) return(0);
      
      //
      //
      //
      //
      //

      if (!UseVoltyTrailingStop)
            double tradeLots = getLots(StopLossPips);
      else         tradeLots = getLots(Volty_initialStopLoss);
      if(AccountFreeMargin()<tradeLots*MarketInfo(s_symbol,MODE_MARGINREQUIRED))
         { showTwoStateMessage("money","Not enough money to trade "+DoubleToStr(tradeLots,2),false); return(0); }
      else showTwoStateMessage("money","Continuing to trade",true);
      
      //
      //
      //
      //
      //
      
      Spread = MarketInfo(s_symbol,MODE_SPREAD)/pipMultiplier;
      if (Spread>WorstSpread) WorstSpread=Spread;
      if (SpreadProtection && Spread>NormalSpread+PipTolerance) DontContinue=1; else DontContinue=0;
      
      //
      //
      //
      //
      //
      
      if (trendDirection==__trendUp   && openedSells==0 && DontContinue==0) Buy(tradeLots);
      if (trendDirection==__trendDown && openedBuys ==0 && DontContinue==0) Sell(tradeLots);
   }  
   return(0);      
}

//----------------------------------------------------------------------------------------
//                                 
//----------------------------------------------------------------------------------------
//
//
//
//    lots and range calculation
//
//
//

double getLots(double range)
{
   RefreshRates();
   double tstep  = MarketInfo(s_symbol,MODE_LOTSTEP);
   double minLot = MarketInfo(s_symbol,MODE_MINLOT);
   double maxLot = MarketInfo(s_symbol,MODE_MAXLOT);
   double lots   = BaseLot;
   if (UseAutomaticMM)
   {
      if (Risk>0)
      {
         lots = AccountFreeMargin()*(Risk/100.0)/(range*MarketInfo(s_symbol,MODE_TICKVALUE)/pPoint);
      }
   }      
return(MathMax(MathMin(lots,maxLot),minLot));   
}


//----------------------------------------------------------------------------------------
//       trend determination       
//----------------------------------------------------------------------------------------
//
//
//
//
//

int findTrend()
{
   RefreshRates();
   
   //
   //
   //
   //
   //
   
   double Buy1_1  = iMA(s_symbol, 0, fastMa, 0, fastMaMode, PRICE_CLOSE, CurrentBar+1); 
   double Buy1_2  = iMA(s_symbol, 0, slowMa, 0, slowMaMode, PRICE_CLOSE, CurrentBar+1);
   double Buy2_1  = iMA(s_symbol, 0, fastMa, 0, fastMaMode, PRICE_CLOSE, CurrentBar); 
   double Buy2_2  = iMA(s_symbol, 0, slowMa, 0, slowMaMode, PRICE_CLOSE, CurrentBar); 
   double Buy3_1  = iSAR(s_symbol, 0, step, maximum, CurrentBar+1);  
   double Buy3_2  = iSAR(s_symbol, 0, step, maximum, CurrentBar);
   double Buy4_1  = iMACD(s_symbol, 0, FastMACD, SlowMACD, SignalMACD, PRICE_CLOSE, MODE_SIGNAL, CurrentBar+1);
   double Buy4_2  = iMACD(s_symbol, 0, FastMACD, SlowMACD, SignalMACD, PRICE_CLOSE, MODE_SIGNAL, CurrentBar);
   double Sell1_1 = iMA(s_symbol, 0, fastMa, 0, fastMaMode, PRICE_CLOSE, CurrentBar+1);
   double Sell1_2 = iMA(s_symbol, 0, slowMa, 0, slowMaMode, PRICE_CLOSE, CurrentBar+1);
   double Sell2_1 = iMA(s_symbol, 0, fastMa, 0, fastMaMode, PRICE_CLOSE, CurrentBar);
   double Sell2_2 = iMA(s_symbol, 0, slowMa, 0, slowMaMode, PRICE_CLOSE, CurrentBar);
   double Sell3_1 = iSAR(s_symbol, 0, step, maximum, CurrentBar+1);
   double Sell3_2 = iSAR(s_symbol, 0, step, maximum, CurrentBar);
   double Sell4_1 = iMACD(s_symbol, 0, FastMACD, SlowMACD, SignalMACD, PRICE_CLOSE, MODE_SIGNAL,CurrentBar+1);
   double Sell4_2 = iMACD(s_symbol, 0, FastMACD, SlowMACD, SignalMACD, PRICE_CLOSE, MODE_SIGNAL,CurrentBar);
   double diIXO10 = iCustom(s_symbol, 0,"XO clean",BoxPeriod,0,CurrentBar);
   double diIXO21 = iCustom(s_symbol, 0,"XO clean",BoxPeriod,1,CurrentBar);
   double d22     = 0;
   
   //
   //
   //
   //
   //

   if (Buy1_1 < Buy1_2 && Buy2_1 >= Buy2_2 && Buy3_1 < Buy3_2 && Buy4_1 < Buy4_2 && diIXO10 > d22)        return(__trendUp);
   if (Sell1_1 > Sell1_2 && Sell2_1 <= Sell2_2 && Sell3_1 > Sell3_2 && Sell4_1 > Sell4_2 && diIXO21< d22) return(__trendDown);
                                                                                                          return(__trendNeutral);
}

//----------------------------------------------------------------------------------------
//       orders counters
//----------------------------------------------------------------------------------------
//
//
//
//
//

int countOpenedOrders(int& openedBuys,int& openedSells,double& totalProfit)
{
   int openedOrders = 0;   
       openedBuys   = 0;
       openedSells  = 0;
       totalProfit  = 0;
   
   //
   //
   //
   //
   //
      
   for(int i=0; i < OrdersTotal(); i++)
   {
      if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES) == false) break;
   
      //
      //
      //
      //
      //
      
      if(AllSymbolsForProfitAndLoss)
      {
         if(OrderMagicNumber() == MagicNumber)
         if(OrderType() == OP_BUY || OrderType() == OP_SELL) totalProfit  += (OrderProfit()+OrderSwap()); 
      }
      if(OrderSymbol() != s_symbol) continue;
      if(NoHedge)
      {
         if(OrderType() == OP_BUY)  openedBuys++; 
         if(OrderType() == OP_SELL) openedSells++;
      }
      if(OrderMagicNumber() != MagicNumber) continue;
                  
      //
      //
      //
      //
      //
                  
      if(OrderType() == OP_BUY || OrderType() == OP_SELL) { openedOrders++; if (!AllSymbolsForProfitAndLoss) totalProfit  += (OrderProfit()+OrderSwap()); }
   }      
   return(openedOrders);
}

//
//
//
//
//

int countClosedOrders()
{
   int      closedAtBar = 0;    
   int      barShift    = iBarShift(s_symbol,0,Time[0]);
   
   for(int i = OrdersHistoryTotal()-1; i >= 0 ; i--)
   {
      if(OrderSelect(i, SELECT_BY_POS, MODE_HISTORY) == false) break;
      if(OrderMagicNumber() != MagicNumber)                continue;
      if(OrderSymbol()      != s_symbol)                   continue;
      if(iBarShift(s_symbol,0,OrderOpenTime())!= barShift) continue; 
         closedAtBar++;
         break;
   } 
   return(closedAtBar); 
}  

//
//
//
//
//

int countOpenedOnACurrentBar()
{
   int      openedAtBar = 0;    
   datetime startTime   = Time[0];
   datetime endTime     = Time[0]+Period()*60;
   
   for(int i=0; i < OrdersTotal(); i++)
   {
      if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES) == false) break;
      if(OrderMagicNumber() != MagicNumber)                     continue;
      if(OrderSymbol()      != s_symbol)                        continue;
      if(OrderOpenTime()<startTime || OrderOpenTime()>=endTime) continue; 
         openedAtBar++;
         break;
   } 
   return(openedAtBar); 
}  

//----------------------------------------------------------------------------------------
//       opened orders management 
//----------------------------------------------------------------------------------------
//
//
//
//
//

void manageOpenedOrders(int currentDirection,bool doCloseOnTrendChange, bool stoped)
{
   double TakeProfit = TakeProfitPips*pPoint*pipMultiplier;
   double StopLoss   = StopLossPips  *pPoint*pipMultiplier;
   double newStop;
   double curStop;
   double maxStop;
   
   //
   //
   //
   //
   //
   
   for(int i=OrdersTotal()-1; i>=0 ; i--)
   {
      if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES) == false) break;
      
      //
      //
      //    check if stop when profit was signaled
      //    do not trade untill the sell stop order expires or is deleted
      //
      //

      if(OrderMagicNumber() == IEAMessagesIDMagic && OrderType()==OP_BUYLIMIT && StopWhenClosedAllTrades)
      {
         if (StringSubstr(OrderComment(),0,IEAMessagesIDLength)==IEAMessagesID)
         {
            int pos = StringFind(OrderComment(),IEAMessagesIDExSep);
            if (pos>-1)
            {
               datetime expiring = StrToDouble(StringSubstr(OrderComment(),pos+4,0));
                     if(expiring <= TimeCurrent())
                     {
                        dummyResult = OrderDelete(OrderTicket());
                        return;
                     }                        
            }
            CloseAll(); stoped=true; return;
         }            
      }

      //
      //
      //
      //
      //
      
      if(OrderMagicNumber() != MagicNumber) continue;
      if(OrderSymbol()      != s_symbol)    continue;

      //
      //
      //
      //
      //

      int err = 0;      
      if(OrderType() == OP_BUY)
      {
         int ticketB = OrderTicket();
         if (doCloseOnTrendChange) { if (currentDirection==__trendDown) { CloseOrder(0,ticketB); continue; }}
         if (EcnBroker && StopLoss>0)   { if (OrderStopLoss()==0)   { RefreshRates(); setStopLoss(ticketB  ,OrderOpenPrice()-StopLoss);}}
         if (EcnBroker && TakeProfit>0) { if (OrderTakeProfit()==0) { RefreshRates(); setTakeProfit(ticketB,OrderOpenPrice()+TakeProfit);}}
         
         //
         //
         //
         //
         //
         
         for(int c=0; c < NumberOfTries; c++)
         { 
            RefreshRates();
               if (!UseVoltyTrailingStop)
                     double trailingStopBuy = MarketInfo(s_symbol,MODE_BID)-lTrailingStop*pPoint*pipMultiplier;
               else         trailingStopBuy = volbuyValue(s_symbol);
            
               //
               //
               //
               //
               //
               
               curStop = NormalizeDouble(OrderStopLoss(),digit);
               newStop = NormalizeDouble(trailingStopBuy,digit);
               maxStop = NormalizeDouble(MarketInfo(s_symbol,MODE_BID)-MarketInfo(s_symbol,MODE_STOPLEVEL)*pPoint,digit);
               if (TrailOnlyWhenInProfit)
                  bool canTrailBuy = (MarketInfo(s_symbol,MODE_BID)-OrderOpenPrice()) > lTrailingStop*pPoint*pipMultiplier;
               else    canTrailBuy = true;                  
               if (canTrailBuy && newStop > curStop && newStop <= maxStop)
               {
                  dummyResult = OrderModify(OrderTicket(),OrderOpenPrice(),newStop,OrderTakeProfit(),0);
                  err = GetLastError(); checkError("stop loss modified",err);
               }
        			switch (err)
 	       	   {
        			   case ERR_SERVER_BUSY:
		            case ERR_NO_CONNECTION:
		            case ERR_INVALID_PRICE:
		            case ERR_OFF_QUOTES:
		            case ERR_BROKER_BUSY:
		            case ERR_TRADE_CONTEXT_BUSY:
			                 Sleep(PAUSE_BEFORE_RETRY);
			                 continue;

		            case ERR_PRICE_CHANGED:
		            case ERR_REQUOTE:
				              continue;

		            default:
			                 c=NumberOfTries;
			                 continue;
               }
         }
      }
      
      //
      //
      //
      //
      //
      
      if(OrderType() == OP_SELL)
      {
         int ticketS = OrderTicket();
         if (doCloseOnTrendChange) { if (currentDirection==__trendUp) { CloseOrder(0,ticketS); continue; }}
         if (EcnBroker && StopLoss>0)   { if (OrderStopLoss()==0)   { RefreshRates(); setStopLoss(ticketS  ,OrderOpenPrice()+StopLoss);}}
         if (EcnBroker && TakeProfit>0) { if (OrderTakeProfit()==0) { RefreshRates(); setTakeProfit(ticketS,OrderOpenPrice()-TakeProfit);}}

         //
         //
         //
         //
         //
         
         for(c=0; c < NumberOfTries; c++)
         { 
            RefreshRates();
               if (!UseVoltyTrailingStop)
                     double trailingStopSell = MarketInfo(s_symbol,MODE_BID)+sTrailingStop*pPoint*pipMultiplier;
               else         trailingStopSell = volsellValue(s_symbol);
               
               //
               //
               //
               //
               //
               
               curStop = NormalizeDouble(OrderStopLoss(),digit);
               newStop = NormalizeDouble(trailingStopSell,digit);
               maxStop = NormalizeDouble(MarketInfo(s_symbol,MODE_ASK)+MarketInfo(s_symbol,MODE_STOPLEVEL)*pPoint,digit);
               if (TrailOnlyWhenInProfit)
                  bool canTrailSell = (OrderOpenPrice()-MarketInfo(s_symbol,MODE_ASK)) > lTrailingStop*pPoint*pipMultiplier;
               else    canTrailSell = true;                  
               if (canTrailSell && curStop > 0 && newStop < curStop && newStop > maxStop)
               {
                  dummyResult = OrderModify(OrderTicket(),OrderOpenPrice(),newStop,OrderTakeProfit(),0);
                  err = GetLastError(); checkError("stop loss modified",err);
               }                        
        			switch (err)
  	       	   {
        			   case ERR_SERVER_BUSY:
		            case ERR_NO_CONNECTION:
		            case ERR_INVALID_PRICE:
		            case ERR_OFF_QUOTES:
		            case ERR_BROKER_BUSY:
		            case ERR_TRADE_CONTEXT_BUSY:
   		                 Sleep(PAUSE_BEFORE_RETRY);
	  	                    continue;

		            case ERR_PRICE_CHANGED:
		            case ERR_REQUOTE:
   			              continue;

		            default:
			                 c=NumberOfTries;
			                 continue;
               }
         }                  
      }
   }
}

//----------------------------------------------------------------------------------------
//       orders management
//----------------------------------------------------------------------------------------
//       buy and sell orders
//----------------------------------------------------------------------------------------
//
//
//
//
//

void setStopLoss(int ticket,double stopLoss)
{
   if (ticket != -1)
   {
      for(int c=0; c < NumberOfTries; c++)
      {
         double minStop = 0;
         bool   canGo   = false;
         if (OrderType()==OP_BUY)
               { minStop = MarketInfo(s_symbol,MODE_BID)-MarketInfo(s_symbol,MODE_STOPLEVEL)*pPoint; canGo = stopLoss<=minStop; }
         else  { minStop = MarketInfo(s_symbol,MODE_ASK)+MarketInfo(s_symbol,MODE_STOPLEVEL)*pPoint; canGo = stopLoss>=minStop; }
         if (canGo)
         {
            dummyResult = OrderModify(ticket,OrderOpenPrice(),stopLoss,OrderTakeProfit(),0);
               int     err = GetLastError(); checkError("stop loss applied",err);
               switch (err)
	    	      {
                  case ERR_SERVER_BUSY:
                  case ERR_NO_CONNECTION:
                  case ERR_INVALID_PRICE:
                  case ERR_OFF_QUOTES:
                  case ERR_BROKER_BUSY:
                  case ERR_TRADE_CONTEXT_BUSY:
      			        Sleep(PAUSE_BEFORE_RETRY);
   	  		           continue;

                  case ERR_PRICE_CHANGED:
	    		      case ERR_REQUOTE:
	     			        continue;

                  default:
	                   c = NumberOfTries;
	                    continue;
             }
         }            
      }
      dummyResult = OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES);      
   }   
}

//
//
//
//
//

void setTakeProfit(int ticket,double takeProfit)
{
   if (ticket != -1)
   {
      for(int c=0; c < NumberOfTries; c++)
      {
         dummyResult = OrderModify(ticket,OrderOpenPrice(),OrderStopLoss(),takeProfit,0);
            int     err = GetLastError(); checkError("take profit applied",err);
            switch (err)
   	  	   {
               case ERR_SERVER_BUSY:
               case ERR_NO_CONNECTION:
               case ERR_INVALID_PRICE:
               case ERR_OFF_QUOTES:
               case ERR_BROKER_BUSY:
               case ERR_TRADE_CONTEXT_BUSY:
	  		           Sleep(PAUSE_BEFORE_RETRY);
   			        continue;

               case ERR_PRICE_CHANGED:
	  		      case ERR_REQUOTE:
   				     continue;

               default:
	                 c=NumberOfTries;
	                continue;
            }
      }
      dummyResult = OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES);      
   }   
}

//
//
//
//
//

void Buy(double Lots)
{ 
   double TakeProfit = TakeProfitPips*pPoint*pipMultiplier;
   double StopLoss   = StopLossPips  *pPoint*pipMultiplier;
   if (UseVoltyTrailingStop)
          StopLoss   = Volty_initialStopLoss*pPoint*pipMultiplier;
   
   //
   //
   //
   //
   //
   
   if (IsTesting() || CheckTradeAllowed())
   for(int c=0; c < NumberOfTries; c++)
   { 
      RefreshRates();
      double sl=0;
      double tp=0;
         if (!EcnBroker)
         {
            if (StopLoss > 0)   sl = MarketInfo(s_symbol,MODE_ASK)-StopLoss;
            if (TakeProfit > 0) tp = MarketInfo(s_symbol,MODE_ASK)+TakeProfit;
         }            
         int ticket = OrderSend(s_symbol,OP_BUY,Lots,MarketInfo(s_symbol,MODE_ASK),AllowedSlippage*pipMultiplier,sl,tp,"Scalp_net-buy",MagicNumber,0,Blue);
         
         //
         //
         //
         //
         //
         
         int     err = GetLastError(); checkError("buy order opened",err);
  			switch (err)
         {
            case ERR_NO_ERROR:
                 if (EcnBroker && StopLoss>0)   setStopLoss(ticket,MarketInfo(s_symbol,MODE_ASK)-StopLoss);
                 if (EcnBroker && TakeProfit>0) setTakeProfit(ticket,MarketInfo(s_symbol,MODE_ASK)+TakeProfit);
                     c=NumberOfTries;
                 continue;
			                 
			   case ERR_SERVER_BUSY:
            case ERR_NO_CONNECTION:
            case ERR_INVALID_PRICE:
            case ERR_OFF_QUOTES:
            case ERR_BROKER_BUSY:
            case ERR_TRADE_CONTEXT_BUSY:
                 Sleep(PAUSE_BEFORE_RETRY);
                 continue;

            case ERR_PRICE_CHANGED:
            case ERR_REQUOTE:
	              continue;

            default:
                 c=NumberOfTries;
                 continue;
         }
   } 	    
}

//
//
//
//
//

void Sell(double Lots)
{        
   double TakeProfit = TakeProfitPips*pPoint*pipMultiplier;
   double StopLoss   = StopLossPips  *pPoint*pipMultiplier;
   if (UseVoltyTrailingStop)
          StopLoss   = Volty_initialStopLoss*pPoint*pipMultiplier;
      
   //
   //
   //
   //
   //
   
   if (IsTesting() || CheckTradeAllowed())
   for(int c=0;c < NumberOfTries; c++)
   { 
      RefreshRates();
      double sl=0;
      double tp=0;
         if (!EcnBroker)
         {
            if (StopLoss > 0)   sl = MarketInfo(s_symbol,MODE_BID)+StopLoss;
            if (TakeProfit > 0) tp = MarketInfo(s_symbol,MODE_BID)-TakeProfit;
         }
         int ticket = OrderSend(s_symbol,OP_SELL,Lots,MarketInfo(s_symbol,MODE_BID),AllowedSlippage*pipMultiplier,sl,tp,"Scalp_net-sell",MagicNumber,0,Red);
         
         //
         //
         //
         //
         //
         
         int     err = GetLastError(); checkError("sell order opened",err);
  			switch (err)
         {
            case ERR_NO_ERROR:
                 if (EcnBroker && StopLoss>0)   setStopLoss(ticket,MarketInfo(s_symbol,MODE_BID)+StopLoss);
                 if (EcnBroker && TakeProfit>0) setTakeProfit(ticket,MarketInfo(s_symbol,MODE_BID)-TakeProfit);
                     c=NumberOfTries;
                 continue;
			                 
			   case ERR_SERVER_BUSY:
            case ERR_NO_CONNECTION:
            case ERR_INVALID_PRICE:
            case ERR_OFF_QUOTES:
            case ERR_BROKER_BUSY:
            case ERR_TRADE_CONTEXT_BUSY:
                 Sleep(PAUSE_BEFORE_RETRY);
                 continue;

            case ERR_PRICE_CHANGED:
            case ERR_REQUOTE:
	              continue;

            default:
                 c = NumberOfTries;
                 continue;
         }
   }
}

//----------------------------------------------------------------------------------------
//       orders closing and closing all (take profit mode)
//----------------------------------------------------------------------------------------
//
//
//
//
//

void CloseAll()
{
   for (int i=OrdersTotal()-1; i>=0; i--)
   { 
      dummyResult = OrderSelect(i, SELECT_BY_POS,MODE_TRADES);
      if (OrderMagicNumber()!=MagicNumber) continue;
      if (!AllSymbolsForProfitAndLoss)
      if (OrderSymbol() != s_symbol)       continue;

      //
      //
      //
      //
      //

      if (OrderType()==OP_BUY || OrderType()==OP_SELL)
      {
         for(int c=0 ; c<3; c++)
         {
            RefreshRates();
               if (OrderType()==OP_BUY)
                     double cp = MarketInfo(s_symbol,MODE_BID);  
               else         cp = MarketInfo(s_symbol,MODE_ASK);
               
            //
            //
            //
            //
            //
                           
            dummyResult = OrderClose(OrderTicket(),OrderLots(),cp,0,CLR_NONE);
            int     err=GetLastError(); checkError(s_symbol+" order closed",err);
     			switch (err)
            {
   			   case ERR_SERVER_BUSY:
               case ERR_NO_CONNECTION:
               case ERR_INVALID_PRICE:
               case ERR_OFF_QUOTES:
               case ERR_BROKER_BUSY:
               case ERR_TRADE_CONTEXT_BUSY:
                    Sleep(PAUSE_BEFORE_RETRY);
                    continue;

               case ERR_PRICE_CHANGED:
               case ERR_REQUOTE:
	                continue;

               default:
                    c=NumberOfTries;
                    continue;
            }                 
         }
      }
   }
}

//
//
//
//
//

void CloseOrder(double lotsToClose=0,int ticket=-1)
{
   double minLot = NormalizeDouble(MarketInfo(s_symbol,MODE_MINLOT),2);
   string message;

   //
   //
   //
   //
   //
      
   if (IsTesting() || CheckTradeAllowed())
   for(int i=OrdersTotal()-1; i>=0; i--)
   {
      dummyResult = OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if (OrderMagicNumber()!=MagicNumber) continue;
      if (OrderSymbol() != s_symbol)       continue;
      if (ticket!=-1)
         if (OrderTicket()!=ticket) continue;
         
      //
      //
      //
      //
      //
         
      if (OrderType()==OP_BUY || OrderType()==OP_SELL)
      {
         if (OrderType()==OP_BUY)
               { string operation = "buy"; color theColor  = Blue;}  
         else  {        operation = "sell";      theColor  = Red; }
            
         //
         //
         //
         //
         //

         if (lotsToClose==0) lotsToClose = OrderLots();
         if (lotsToClose!=OrderLots())
         {
            lotsToClose = MathMax(minLot,lotsToClose);
               if (OrderLots() < 2.0*minLot)
                  lotsToClose = OrderLots();
         }               
            
         if (lotsToClose!=OrderLots())
                  message="partialy closed "+operation+" - closed "+DoubleToStr(lotsToClose,2)+" lots";
         else     message=operation+" order closed";
            
         //
         //
         //
         //
         //
            
         for(int c=0 ; c < NumberOfTries; c++)
         {
            RefreshRates();
            if (OrderType()==OP_BUY)
                  double cp = MarketInfo(s_symbol,MODE_BID);  
            else         cp = MarketInfo(s_symbol,MODE_ASK);
               
            //
            //
            //
            //
            //
               
            dummyResult = OrderClose(OrderTicket(),lotsToClose,cp,AllowedSlippage*pipMultiplier,theColor);
            int err=GetLastError();  checkError(message,err);
     			switch (err)
            {
    			   case ERR_SERVER_BUSY:
               case ERR_NO_CONNECTION:
               case ERR_INVALID_PRICE:
               case ERR_OFF_QUOTES:
               case ERR_BROKER_BUSY:
               case ERR_TRADE_CONTEXT_BUSY:
                    Sleep(PAUSE_BEFORE_RETRY);
                    continue;

               case ERR_PRICE_CHANGED:
               case ERR_REQUOTE:
    	              continue;

               default:
                    c=NumberOfTries;
                    continue;
            }
         }
      }            
   }  
}

//----------------------------------------------------------------------------------------
//       miscellaneus functions           
//----------------------------------------------------------------------------------------
//
//
//
//
//

string normalizeTime(string time)
{
   int sepAt  = StringFind(time,":",0);
   int hour   = StrToInteger(StringSubstr(time,0,sepAt));
   int minute = StrToInteger(StringSubstr(time,sepAt+1,0));
   
   //
   //
   //
   //
   //
   
   hour   = MathMax(MathMin(hour  ,24),0);
   minute = MathMax(MathMin(minute,59),0);
   string answer="";
      while(true)
      {
         if (hour==0) { answer="00";     break; }
         if (hour<10) { answer="0"+hour; break; }
                        answer=    hour; break; 
      }                        
      while(true)
      {
         if (minute==0) { answer=answer+":00";       break; }
         if (minute<10) { answer=answer+":0"+minute; break; }
                          answer=answer+":" +minute; break; 
      }
   return(" "+answer); 
}

//
//
//
//
//

double volbuyValue(string symbol)
{
   double volbuy = iCustom(symbol,vol_timeFrame,"Volty Channel Stop on jurik-for Ea",0,Price,Length,Phase,Double,AtrLength,Kv,MoneyRisk,0,0,vol_barToUse);
   return(volbuy);
}

double volsellValue(string symbol)
{
   double volsell = iCustom(symbol,vol_timeFrame,"Volty Channel Stop on jurik-for Ea",0,Price,Length,Phase,Double,AtrLength,Kv,MoneyRisk,0,1,vol_barToUse);
   return(volsell);
}

//----------------------------------------------------------------------------------------
//       terminal status handling
//----------------------------------------------------------------------------------------
//
//
//
//
//

bool CheckTradeAllowed() { return(IsTradeAllowed() && !IsStopped() && IsExpertEnabled() && !IsTradeContextBusy()); }
bool CheckTerminalStatus()
{
   bool status=false;
   
   //
   //
   //
   //
   //
   
   while(true)
   {
         if (!IsConnected())
             { showTwoStateMessage("connected","No connection to server",False); break; }
         else  showTwoStateMessage("connected","Reconected to server",true);
         if ( IsStopped())
             { showTwoStateMessage("stopped","EA stopped",False); break; }  
         else  showTwoStateMessage("stopped","EA started again",true);
         if (!IsTradeAllowed())
             { showTwoStateMessage("allowed","Trading not allowed",false); break; }
         else  showTwoStateMessage("allowed","Trading allowed again",true);
         if (!IsExpertEnabled() && !IsTesting())
            { showTwoStateMessage("disabled","EA''s are disabled",false); break; }
         else showTwoStateMessage("disabled","EA''s are enabled again",true);
         if ( IsTradeContextBusy())
            { showTwoStateMessage("busy","Trade contest busy",false); break; }
         else showTwoStateMessage("busy","Trade contest ready again",true);

      //
      //
      //
      //
      //
      
      status=true;
      break;
   }
   if (SpreadProtection)
   {
      if (DontContinue==1)
            showTwoStateMessage("spreads","Spreads widen",false);
      else  showTwoStateMessage("spreads","Spreads normal again",true);
   }            
   return(status);
}

//----------------------------------------------------------------------------------------
//       inter EA messages handling
//----------------------------------------------------------------------------------------
//
//
//
//
//
//

bool FindMessage()
{
   bool found=false;
   for (int i=OrdersTotal()-1; i>=0; i--)
   {
      if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
      if (OrderMagicNumber() == IEAMessagesIDMagic)
      if (OrderComment()     == IEAMessagesID)
      {
        found=true; break;
      }
   }
   return(found);
}

//
//
//
//
//

void PostMessage()
{
   string   message    = IEAMessagesID;
   int      timeToAdd  = 660;
   double   lot        = MarketInfo(s_symbol,MODE_MINLOT);
   datetime expiration = Time[0]+24*3600;
            expiration = StrToTime(TimeToStr(expiration,TIME_DATE)+" 00:00");
   
   //
   //
   //
   //
   //
   
   if (!FindMessage())
   {
     for(int c=0; c<NumberOfTries; c++)
      {
         expiration = MathMax(expiration,TimeCurrent()+timeToAdd);
         
         //
         //
         //
         //
         //
         
         dummyResult = OrderSend(s_symbol,OP_BUYLIMIT,lot,pPoint,0,0,0,message,IEAMessagesIDMagic,expiration,CLR_NONE);
         int err = GetLastError();
      	switch (err)
 	      {
 	         case ERR_TRADE_EXPIRATION_DENIED:
 	               if (expiration !=0)
 	               {
 	                  message    = IEAMessagesID+IEAMessagesIDExSep+expiration;
                     expiration = 0; 	                   
 	               }
 	               continue;
 	         
            case ERR_INVALID_TRADE_PARAMETERS:
                  timeToAdd += 300;
                  continue;

            case ERR_SERVER_BUSY:
		      case ERR_NO_CONNECTION:
		      case ERR_INVALID_PRICE:
		      case ERR_OFF_QUOTES:
		      case ERR_BROKER_BUSY:
		      case ERR_TRADE_CONTEXT_BUSY:
			          Sleep(PAUSE_BEFORE_RETRY);
			          continue;

            case ERR_PRICE_CHANGED:
            case ERR_REQUOTE:
		              continue;

            default:
	                 c=NumberOfTries;
	                 continue;
         }
      }
   }             
}

//----------------------------------------------------------------------------------------
//       messages handling
//----------------------------------------------------------------------------------------
//
//
//
//
//
//

bool   msg_errState[];
string msg_errNames[];
string msg_messageText[20];
color  msg_messageColor[20];
int    msg_lastMessage=0;

//
//
//
//
//

void checkError(string what,int err)
{
   showMessage(what);
   if(err!=ERR_NO_ERROR && err!=ERR_NO_RESULT)
         showMessage("error occured :"+ErrorDescription(err),Red);

}

//
//
//
//
//

void showTwoStateMessage(string name, string message, bool state)
{
   for(int i=ArraySize(msg_errNames)-1; i>=0; i--) if (msg_errNames[i]==name) break;
   if (i==-1)
      {
         int size = ArraySize(msg_errNames)+1;
         i = size-1;
            ArrayResize(msg_errNames,size); msg_errNames[i] = name;
            ArrayResize(msg_errState,size); msg_errState[i] = true;
      }

   //
   //
   //
   //
   //

   if (msg_errState[i]!= state)
   {   
      msg_errState[i] = state;
      if (state==false)
            showMessage(message,Red);
      else  showMessage(message,Green);
   }      
}

//
//
//
//
//

void showMessage(string text, color theColor=Gray)
{
   if(!showMessages) { Print(text); return; }
   
   //
   //
   //
   //
   //
   
   if(msg_lastMessage>19)
   {
      for(int i=0; i<19; i++)
      {
         msg_messageText[i] =msg_messageText[i+1];
         msg_messageColor[i]=msg_messageColor[i+1];
      }
      msg_lastMessage = 19;
   }

   //
   //
   //    set message que text and color
   //
   //
   
      msg_messageText[msg_lastMessage]  = text+" - "+TimeToStr(TimeCurrent(),TIME_DATE|TIME_SECONDS);
      msg_messageColor[msg_lastMessage] = theColor;
   
   //
   //
   //
   //
   //
      
   for(i=0; i<=msg_lastMessage; i++)
   {
      string name = "msg_que"+i;
      if (ObjectFind(name) == -1)
      {
         ObjectCreate(name,OBJ_LABEL,0,0,0);
            ObjectSet(name,OBJPROP_CORNER,3);
            ObjectSet(name,OBJPROP_XDISTANCE,5);
            ObjectSet(name,OBJPROP_YDISTANCE,5+14*i);
      }
      ObjectSetText(name,msg_messageText[i],9,"Arial",msg_messageColor[i]);
   }
   msg_lastMessage++;
   WindowRedraw();
}

//
//
//
//
//

int GetMagic() 
{

   if (StringFind(s_symbol, "CADJPY") >= 0) return(5533921);
   if (StringFind(s_symbol, "CADCHF") >= 0) return(5533922);
   
   if (StringFind(s_symbol, "XAUUSD") >= 0) return(5522231);
   if (StringFind(s_symbol, "XAGUSD") >= 0) return(5522232);
   
   if (StringFind(s_symbol, "NZDJPY") >= 0) return(5533941);
   if (StringFind(s_symbol, "NZDUSD") >= 0) return(5533942);
   
   if (StringFind(s_symbol, "CHFJPY") >= 0) return(5534151);
   
   if (StringFind(s_symbol, "EURAUD") >= 0) return(5534261);
   if (StringFind(s_symbol, "EURCAD") >= 0) return(5534962);
   if (StringFind(s_symbol, "EURUSD") >= 0) return(5534963);
   if (StringFind(s_symbol, "EURGBP") >= 0) return(5534964);
   if (StringFind(s_symbol, "EURCHF") >= 0) return(5534965);
   if (StringFind(s_symbol, "EURNZD") >= 0) return(5534966);
   if (StringFind(s_symbol, "EURJPY") >= 0) return(5534967);
   
   if (StringFind(s_symbol, "GBPUSD") >= 0) return(5534971);
   if (StringFind(s_symbol, "GBPCHF") >= 0) return(5534972);
   if (StringFind(s_symbol, "GBPJPY") >= 0) return(5534973);
   if (StringFind(s_symbol, "GBPNZD") >= 0) return(5534974);
   if (StringFind(s_symbol, "GBPDKK") >= 0) return(5534975);
   
   if (StringFind(s_symbol, "USDCHF") >= 0) return(5534981);
   if (StringFind(s_symbol, "USDJPY") >= 0) return(5534982);
   if (StringFind(s_symbol, "USDCAD") >= 0) return(5534983);
   if (StringFind(s_symbol, "USDDKK") >= 0) return(5534984);

   if (StringFind(s_symbol, "AUDUSD") >= 0) return(5534991);
   if (StringFind(s_symbol, "AUDNZD") >= 0) return(5534992);
   if (StringFind(s_symbol, "AUDCAD") >= 0) return(5534993);
   if (StringFind(s_symbol, "AUDCHF") >= 0) return(5534994);
   if (StringFind(s_symbol, "AUDJPY") >= 0) return(5534995);
   
return(ManualMagic);
}

//
//
//
//
//

double TimeZoneLocal()
{     
	   switch(GetTimeZoneInformation(TZInfoArray))
	   {
	        case TIME_ZONE_ID_UNKNOWN: 
	        Print("Error obtaining PC timezone from GetTimeZoneInformation in kernel32.dll. Returning 0");
		     return(0);

	        case TIME_ZONE_ID_STANDARD:
		     return(TZInfoArray[0]/(-60.0));
	
	        case TIME_ZONE_ID_DAYLIGHT:
		     return((TZInfoArray[0]+TZInfoArray[42])/(-60.0));
		
 	        default:
		     Print("Unkown return value from GetTimeZoneInformation in kernel32.dll. Returning 0");
		     return(0);
	   }
}

// 
//
//
//
//

double TimeZoneServer()
{
	int ServerToLocalDiffMinutes = (TimeCurrent()-TimeLocal())/60;
	int nHalfHourDiff            = MathRound(ServerToLocalDiffMinutes/30.0);
	
	//
	//
	//
	//
	//
	
	ServerToLocalDiffMinutes = nHalfHourDiff*30;
	
return(TimeZoneLocal() + ServerToLocalDiffMinutes/60.0);
}

// 
//
//
//
//

datetime _TimeGMT()
{
	    datetime dtGmtFromLocal = TimeLocal() - TimeZoneLocal()*3600;
	    datetime dtGmtFromServer = TimeCurrent() - TimeZoneServer()*3600;

       if (dtGmtFromLocal > dtGmtFromServer + 300)
	    {
		   return(dtGmtFromLocal);
	    }
	    else
	    {
		  return(dtGmtFromServer);
	    }	
}

//
//
//
//
//

void ChartComment()
{
   RefreshRates();
   if (IsTesting() && !IsVisualMode()) return;
   if (IsTesting()) return;
   
   string symbol   = Symbol(); if (StringSubstr(symbol,0,2)=="_t") symbol = StringSubstr(symbol,2);
  	double modifier = 1;
  	int    digits   = MarketInfo(symbol,MODE_DIGITS);
   if (digits==3 || digits==5) modifier = 10.0;
   
   //
  	//
  	//
  	//
  	//
   
   if(MarketInfo(symbol,MODE_SWAPLONG) > 0)                                string    swap="longs,";
                                                                           else      swap="shorts.";
   if(MarketInfo(symbol,MODE_SWAPLONG) < 0 && MarketInfo(symbol,MODE_SWAPSHORT) < 0) swap="your broker. ";
   
   //
   //
   //
   //
   //
   
   string strLocal  = TimeToStr(TimeLocal(),TIME_DATE|TIME_MINUTES|TIME_SECONDS);
	string strServer = TimeToStr(TimeCurrent(),TIME_DATE|TIME_MINUTES|TIME_SECONDS);
	string strGMT    = TimeToStr(_TimeGMT(),TIME_DATE|TIME_MINUTES|TIME_SECONDS);
	
	string strLocalTimeZone;
	if (TimeZoneLocal() >  0)  strLocalTimeZone  = StringConcatenate("Local timezone: GMT plus  ", TimeZoneLocal()," hours");
	if (TimeZoneLocal() == 0)  strLocalTimeZone  = "Local timezone: GMT";
	if (TimeZoneLocal() <  0)  strLocalTimeZone  = StringConcatenate("Local timezone: GMT minus ",-TimeZoneLocal()," hours");
	
	string strServerTimeZone;
	if (TimeZoneServer() >  0) strServerTimeZone = StringConcatenate("Server timezone: GMT plus  ", TimeZoneServer()," hours");
	if (TimeZoneServer() == 0) strServerTimeZone = "Server timezone: GMT";
  	if (TimeZoneServer() <  0) strServerTimeZone = StringConcatenate("Server timezone: GMT minus ",-TimeZoneServer()," hours");
   
   //
   //
   //
   //
   //
   
   string sComment   = "";
   string sp         = "------------------------------------------------------------\n";
   string NL         = "\n";
       
   sComment = sp;
   sComment = sComment+ "Expert Name : "+ExpertName+NL;
   sComment = sComment+ "EA Version  : "+Version+NL;
   sComment = sComment+ sp;
   sComment = sComment+ "Market Analysis" + NL;
   sComment = sComment+ "Swap favors " + swap + NL; 
   sComment = sComment+ "Swap Long      = " + DoubleToStr(MarketInfo(symbol,MODE_SWAPLONG),2) + NL; 
   sComment = sComment+ "Swap Short     = " + DoubleToStr(MarketInfo(symbol,MODE_SWAPSHORT),2) + NL; 
   sComment = sComment+ "Current Spread = " + DoubleToStr(MarketInfo(symbol,MODE_SPREAD)/ modifier,2) + NL;  
   sComment = sComment+ sp;
   sComment = sComment+ "Time Information" + NL;
   sComment = sComment+ strLocalTimeZone  + NL;
   sComment = sComment+ strServerTimeZone + NL;
   sComment = sComment+ "PC Local Time = " +strLocal+ NL;
   sComment = sComment+ "Broker server time =  " +strServer+ NL;
   sComment = sComment+ "GMT time =  " +strGMT+ NL;
   sComment = sComment+ sp;
   sComment = sComment+ "Have a great trading day" + NL;
   sComment = sComment+ sp; 
   
Comment(sComment);
}




